/*
** No copyright?!
**
** $Id: int.c,v 1.4 1997/03/18 02:36:56 msmith Exp $
*/
#include "doscmd.h"

/*
** Cause a software interrupt to happen immediately after we
** return to vm86 mode
*/
void
softint(int intnum)
{
    regcontext_t	*REGS = saved_regcontext;
    u_long vec = ivec[intnum];

    /*
    ** if we're dead, or there's no vector or the saved registers are
    ** invalid
    */
    if (dead || !saved_valid || vec == 0)
	return;

    /* 
    ** if the vector points into the BIOS, or the handler at the other
    ** end is just an IRET, don't bother.
    */
    if ((vec >> 16) == 0xf000 || *(u_char *)VECPTR(vec) == 0xcf)
	return;

    debug(D_TRAPS|intnum, "Int%x [%04x:%04x]\n", 
	  intnum, vec >> 16, vec & 0xffff);

    N_PUSH(R_FLAGS, REGS);
    N_PUSH(R_CS, REGS);
    N_PUSH(R_IP, REGS);
    N_PUTVEC(R_CS, R_IP, vec);
}

/*
** Cause a hardware interrupt to happen immediately after
** we return to vm86 mode
*/
void
hardint(int intnum)
{
    regcontext_t	*REGS = saved_regcontext;
    /*
     * XXXXX
     * We should simulate the IRQ mask in the PIC.
     */
#if 0
fprintf(stderr, "hardint %s %s\n",
    R_EFLAGS & PSL_VM ? "VM" : "  ",
    R_FLAGS & PSL_I ? "I" : " ");
#endif
#if 0
    if (R_FLAGS & PSL_I) {
#else 
    {
#endif
	u_long vec = ivec[intnum];
	
	/* 
	** if we're dead, or there's no vector, or the saved registers
	** are invalid
	*/
	if (dead || !saved_valid || vec == 0)
	    return;
	
	/* 
	** if the vector points into the BIOS, or the handler at the
	** other end is just an IRET, don't bother 
	*/

	if ((vec >> 16) == 0xf000 || *(u_char *)VECPTR(vec) == 0xcf)
	    return;
	
	debug(D_TRAPS|intnum, "Int%x [%04x:%04x]\n",
	      intnum, vec >> 16, vec & 0xffff);

	N_PUSH(R_FLAGS, REGS);
	N_PUSH(R_CS, REGS);
	N_PUSH(R_IP, REGS);
#if 0
	R_FLAGS &= ~PSL_I;		/* XXX enable interrupts? */
#endif
	N_PUTVEC(R_CS, R_IP, vec);
    }
}
