/*-
 * XXX HEY, PUT A COPYRIGHT HERE!
 */

#ifndef _MACHINE_VM86_H_
#define _MACHINE_VM86_H_ 1

#define VM86_LOAD_MAP	1

/* vm86 support structure that resides in the user area. */

struct vm86_kernel {
        u_long	vm86_eflags;			/* emulated flags */
        u_long  vm86_int_map[256 >> 5];		/* interrupt bitmap */
        u_long  vm86_int21_map[256 >> 5];	/* ... sub-bitmap for int 21 */
	u_long	vm86_magic_iret[2];		/* XXX what is this for? */
};

struct i386_vm86_args {
        int     op;                     /* operation to perform */
        struct  vm86_kernel     vm86;    /* kernel structure */
};


/* standard register representation */
typedef union {
	u_long	r_ex;
	struct {
		u_short	r_x;
		u_short	:16;
	} r_w;
	struct {
		u_char	r_l;
		u_char	r_h;
		u_short	:16;
	} r_b;
} reg86_t;

/* layout must match definition of struct trapframe_vm86 in <machine/frame.h> */

struct vm86frame {
	int	:32;			/* kernel ES */
	int	:32;			/* kernel DS */
	reg86_t	edi;
	reg86_t	esi;
	reg86_t	ebp;
	reg86_t	isp;
	reg86_t	ebx;
	reg86_t	edx;
	reg86_t	ecx;
	reg86_t	eax;
	int	:32;			/* trapno */
	int	:32;			/* err */
	reg86_t	eip;
	reg86_t	cs;
	reg86_t	eflags;
	reg86_t	esp;
	reg86_t	ss;
	reg86_t	es;
	reg86_t	ds;
	reg86_t	fs;
	reg86_t	gs;
#define vmf_cs		cs.r_w.r_x
#define vmf_ss		ss.r_w.r_x
#define vmf_sp		esp.r_w.r_x
#define vmf_ip		eip.r_w.r_x
#define vmf_flags	eflags.r_w.r_x
#define vmf_eflags	eflags.r_ex
};

extern	int (*vm86_emulate) __P((struct vm86frame *));
extern	int (*vm86_sysarch) __P((struct proc *, char *, int *));

#endif /* _MACHINE_VM86_H_ */
